package.path = "./src/?.lua;"..package.path -- This makes Lua looks for modules in some ./src/ folder, as well as the current package path.

require "Object"

keyboard = {}
function do_keyboard(k,s)
	if s then
		keyboard[k] = true
	else
		keyboard[k] = nil
	end
end

theta = 0
phi = 0
function do_point(dx,dy)
	theta = theta-dx/5
	phi = phi-dy/5
	
	if theta > 360 then
		theta = theta - 360
	elseif theta < 0 then
		theta = theta + 360
	end 
	
	if phi > 90 then
		phi = 90
	elseif phi < -90 then
		phi = -90
	end
end

timeSinceLastFrame = 0
function do_timer(dt)
	timeSinceLastFrame = timeSinceLastFrame + dt
end

function do_frame()
	speed = 10
	if keyboard[E.key_a] then
		E.move_entity(camera.obj,-timeSinceLastFrame*speed,0,0)
	end
	if keyboard[E.key_d] then
		E.move_entity(camera.obj,timeSinceLastFrame*speed,0,0)
	end
	if keyboard[E.key_w] then
		E.move_entity(camera.obj,0,0,-timeSinceLastFrame*speed)
	end
	if keyboard[E.key_s] then
		E.move_entity(camera.obj,0,0,timeSinceLastFrame*speed)
	end
	if keyboard[E.key_z] then
		E.move_entity(camera.obj,0,-timeSinceLastFrame*speed,0)
	end
	if keyboard[E.key_q] then
		E.move_entity(camera.obj,0,timeSinceLastFrame*speed,0)
	end
	
	E.set_entity_rotation(camera.obj,phi,theta,0)
	timeSinceLastFrame = 0
end

Object.loadElectroFile(E.argument[1])
camera = Object.getObjectByName("Camera") -- the default camera name. Change it for your scene.
E.enable_timer(true)